MKTEMP(1)

NAME
mktemp - make temporary file name (unique)

SYNOPSIS
mktemp [-dqu] [-p tmpdir] { -t prefix | template ... }

DESCRIPTION
The mktemp utility takes each of the given file name templates and overwrites a portion of it to create a file name. This file name is unique and suitable for use by the application. The template may be any file name with some number of ‘Xs’ appended to it, for example /tmp/temp.XXXX. The trailing ‘Xs’ are replaced with the current process number and/or a unique letter combination. The number of unique file names mktemp can return depends on the number of ‘Xs’ provided; six ‘Xs’ will result in mktemp testing roughly 26 ** 6 combinations.

If mktemp can successfully generate a unique file name, the file is created with mode 0600 (unless the -u flag is given) and the filename is printed to standard output.

If the -t prefix option is given, mktemp will generate a template string based on the prefix and the TMPDIR environment variable, if set. The default location if TMPDIR is not set is /tmp. The default location of the temporary directory can be overridden with the -p tmpdir option. The template string created will consist of the prefix followed by a ‘.’ and an eight character unique letter combination. ‘Xs’ in the prefix string will be treated as literal. If an additional template argument is passed, a second file will be created. Care should be taken to ensure that it is appropriate to use an environment variable potentially supplied by the user.

Any number of temporary files may be created in a single invocation using multiple template arguments, also a single one based on the internal template with the -t option value as filename prefix.

At least one template argument or the -t option must be present.

mktemp is provided to allow shell scripts to safely use temporary files. Traditionally, many shell scripts take the name of the program with the pid as a suffix and use that as a temporary file name. This kind of naming scheme is predictable and the race condition it creates is easy for an attacker to win. A safer, though still inferior, approach is to make a temporary directory using the same naming scheme. While this does allow one to guarantee that a temporary file will not be subverted, it still allows a simple denial of service attack. For these reasons it is suggested that mktemp be used instead.

OPTIONS
The available options are as follows:

-d  Make a directory instead of a file.

-q  Fail silently if an error occurs. This is useful if a script does not want error output to go to standard error.

-t prefix
    Generate a template (using the supplied prefix and TMPDIR if set) to create a filename template. If -t prefix and template are both given, prefix will not apply to template.

-u  Operate in “unsafe” mode. The temp file will be unlinked before mktemp exits. This is slightly better than mktemp(3) but still introduces a race condition. Use of this option is not encouraged.

EXIT STATUS
The mktemp utility exits with a value of 0 on success, and 1 on any failure.

EXAMPLES
The following sh(1) fragment illustrates a simple use of mktemp where the script should quit if it cannot get a safe temporary file.

    TMPFILE=`mktemp /tmp/${0##*/}.XXXXXX` || exit 1
    echo "program output"  $TMPFILE

To allow the use of $TMPDIR:

    TMPFILE=`mktemp -t ${0##*/}` || exit 1
    echo "program output"  $TMPFILE

In this case, we want the script to catch the error itself.

    TMPFILE=`mktemp -q /tmp/${0##*/}.XXXXXX`
    if [ $? -ne 0 ]; then
    	echo "$0: Can't create temp file, exiting..."
    	exit 1
    fi

SEE ALSO
mkdtemp(3), mkstemp(3), mktemp(3), environ(7)

HISTORY
The mktemp utility appeared in NetBSD 1.5. It has been imported from FreeBSD, the idea and the manual page were taken from OpenBSD.